Debian Bug report logs - #653948
cephes_smirnov never returns on mips

version graph

Package: python-scipy; Maintainer for python-scipy is Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>; Source for python-scipy is src:python-scipy.

Reported by: Yaroslav Halchenko <debian@onerussian.com>

Date: Sun, 1 Jan 2012 21:09:02 UTC

Severity: serious

Found in version python-scipy/0.9.0+dfsg1-1

Fixed in version python-scipy/0.10.1+dfsg1-2

Done: Varun Hiremath <varun@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#653948; Package python-scipy. (Sun, 01 Jan 2012 21:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Yaroslav Halchenko <debian@onerussian.com>:
New Bug report received and forwarded. Copy sent to Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sun, 01 Jan 2012 21:09:07 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Yaroslav Halchenko <debian@onerussian.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: cephes_smirnov never returns on mips
Date: Sun, 01 Jan 2012 16:08:12 -0500
Package: python-scipy
Version: 0.9.0+dfsg1-1+b2
Severity: serious
Justification: fails to build from source (but built successfully in the past)

I have ran into this while building pymvpa2 packages.  on mips and mipsel it
times out.

I have troubleshooted it on gabrielli and  I believe the following snippet
should reproduce it (warns but returns fine after all on my laptop
amd64):

$> cat scipy-fit.py 
#!/usr/bin/python

from numpy import array

from scipy.stats.distributions import ksone

print ksone.fit(array([ 0.14328729,  0.25490644,  0.13804094,  0.49698268,  0.1380734 ,
        0.42811492, -0.1115938 , -0.31843031,  0.09982475, -0.2468207 ,
       -0.18507596,  0.38959311,  0.1849186 , -0.18565553,  0.06733078,
       -0.17673704,  0.00511101, -0.22497416,  0.3387749 ,  0.14232358,
        0.43253836,  0.02236981, -0.0588139 , -0.1195712 ,  0.04046193,
        0.04705898, -0.08171521, -0.10318616,  0.20083469, -0.4830056 ,
       -0.14728118,  0.0365655 , -0.26662431,  0.16725666, -0.36558027,
       -0.09645765,  0.12076468,  0.30362135, -0.09133471, -0.26500672,
       -0.08376685, -0.0062318 ,  0.26514818, -0.32202921,  0.2390966 ,
       -0.1353733 , -0.0616442 ,  0.15498897]))

here is how it looks in gdb:

(gdb) bt 10
#0  __ieee754_pow (x=nan(0x7ffffffffffff), y=-1716592327) at ../sysdeps/ieee754/dbl-64/e_pow.c:74
#1  0x2adb2860 in __pow (x=nan(0x7ffffffffffff), y=-1716592327) at w_pow.c:34
#2  0x2beb413c in cephes_smirnov () from /usr/lib/python2.6/dist-packages/scipy/special/_cephes.so
#3  0x2be91fac in PyUFunc_dd_d_As_id_d () from /usr/lib/python2.6/dist-packages/scipy/special/_cephes.so
#4  0x2b15fddc in _ftext () from /usr/lib/pymodules/python2.6/numpy/core/umath.so
#5  0x2b131190 in ?? () from /usr/lib/pymodules/python2.6/numpy/core/multiarray.so
warning: GDB can't find the start of the function at 0x2b13118e.

    GDB is unable to find the start of the function at 0x2b13118e
and thus can't determine the size of that function's stack frame.
This means that GDB may be unable to access that stack frame, or
the frames below it.
    This problem is most likely caused by an invalid program counter or
stack pointer.
    However, if you think GDB should simply search farther back
from 0x2b13118e for code which looks like the beginning of a
function, you can increase the range of the search using the `set
heuristic-fence-post' command.
(gdb) finish
Run till exit from #0  __ieee754_pow (x=nan(0x7ffffffffffff), y=-1716592327) at ../sysdeps/ieee754/dbl-64/e_pow.c:74
0x2adb2860 in __pow (x=nan(0x7ffffffffffff), y=-1716592327) at w_pow.c:34
34      w_pow.c: No such file or directory.
        in w_pow.c
Value returned is $1 = nan(0x8000000000000)
(gdb) finish
Run till exit from #0  0x2adb2860 in __pow (x=nan(0x7ffffffffffff), y=-1716592327) at w_pow.c:34
0x2beb413c in cephes_smirnov () from /usr/lib/python2.6/dist-packages/scipy/special/_cephes.so
Value returned is $2 = nan(0x8000000000000)
(gdb) finish
Run till exit from #0  0x2beb413c in cephes_smirnov () from /usr/lib/python2.6/dist-packages/scipy/special/_cephes.so




^C
Program received signal SIGINT, Interrupt.
0x2beb414c in cephes_smirnov () from /usr/lib/python2.6/dist-packages/scipy/special/_cephes.so
(gdb) print "it stalled for more than a day and never returned from this function"



-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (900, 'testing'), (600, 'unstable'), (300, 'experimental'), (100, 'stable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.0.0-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages python-scipy depends on:
ii  libamd2.2.0                          1:3.4.0-2     
ii  libatlas3gf-base [liblapack.so.3gf]  3.8.3-27      
ii  libblas3gf [libblas.so.3gf]          1.2.20110419-2
ii  libc6                                2.13-18       
ii  libgcc1                              1:4.6.1-4     
ii  libgfortran3                         4.6.1-4       
ii  liblapack3gf [liblapack.so.3gf]      3.3.1-1       
ii  libstdc++6                           4.6.1-4       
ii  libumfpack5.4.0                      1:3.4.0-2     
ii  python                               2.7.2-9       
ii  python-numpy                         1:1.5.1-3     
ii  python2.6                            2.6.7-3       
ii  python2.7                            2.7.2-8       

Versions of packages python-scipy recommends:
ii  g++ [c++-compiler]      4:4.6.1-2
ii  g++-4.3 [c++-compiler]  4.3.5-4  
ii  g++-4.4 [c++-compiler]  4.4.6-8  
ii  g++-4.6 [c++-compiler]  4.6.1-4  

Versions of packages python-scipy suggests:
ii  python [python-profiler]  2.7.2-9

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#653948; Package python-scipy. (Sat, 31 Mar 2012 01:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Yaroslav Halchenko <lists@onerussian.com>:
Extra info received and forwarded to list. Copy sent to Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 31 Mar 2012 01:54:03 GMT) Full text and rfc822 format available.

Message #10 received at 653948@bugs.debian.org (full text, mbox):

From: Yaroslav Halchenko <lists@onerussian.com>
To: SciPy Developers List <scipy-dev@scipy.org>
Cc: 653948@bugs.debian.org
Subject: Re: [SciPy-Dev] cephes_smirnov never returns on mips/sparc/...
Date: Fri, 30 Mar 2012 21:50:56 -0400
yeap -- that

-  if (n <= 0 || e < 0.0 || e > 1.0)
+  /* This comparison should assure returning NaN whenever
+     e is NaN itself.  In original || form it would proceed */
+  if (!(n > 0 && e >= 0.0 && e <= 1.0))


resolved the stalling issue and now I am getting the same
(1.0, nan, nan) as on x86 ... sent pull request

https://github.com/scipy/scipy/pull/187

patch is attached here as well

so next I guess is to make it return sensible values for the .fit as it did
before? ;)

On Fri, 30 Mar 2012, Yaroslav Halchenko wrote:

> well -- imho it should have not even got to that point if e is
> NaN.  Just started rebuilding with following patch:

> -  if (n <= 0 || e < 0.0 || e > 1.0)
> +  # This comparison should assure returning NaN whenever
> +  # e is NaN itself.  In original || form it would proceed
> +  if !(n > 0 && e >= 0.0 && e <= 1.0)
>      return (NPY_NAN);


-- 
=------------------------------------------------------------------=
Keep in touch                                     www.onerussian.com
Yaroslav Halchenko                 www.ohloh.net/accounts/yarikoptic




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#653948; Package python-scipy. (Sat, 31 Mar 2012 01:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Yaroslav Halchenko <debian@onerussian.com>:
Extra info received and forwarded to list. Copy sent to Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 31 Mar 2012 01:54:04 GMT) Full text and rfc822 format available.

Message #15 received at 653948@bugs.debian.org (full text, mbox):

From: Yaroslav Halchenko <debian@onerussian.com>
To: SciPy Developers List <scipy-dev@scipy.org>, 653948@bugs.debian.org
Subject: Re: [SciPy-Dev] cephes_smirnov never returns on mips/sparc/...
Date: Fri, 30 Mar 2012 21:52:25 -0400
[Message part 1 (text/plain, inline)]
d'oh -- now patch is attached

On Fri, 30 Mar 2012, Yaroslav Halchenko wrote:

> patch is attached here as well

-- 
=------------------------------------------------------------------=
Keep in touch                                     www.onerussian.com
Yaroslav Halchenko                 www.ohloh.net/accounts/yarikoptic
[0001-BUG-smirnov-make-comparison-robust-to-handle-NaNs.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#653948; Package python-scipy. (Sat, 31 Mar 2012 02:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to josef.pktd@gmail.com:
Extra info received and forwarded to list. Copy sent to Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 31 Mar 2012 02:30:03 GMT) Full text and rfc822 format available.

Message #20 received at 653948@bugs.debian.org (full text, mbox):

From: josef.pktd@gmail.com
To: SciPy Developers List <scipy-dev@scipy.org>, 653948@bugs.debian.org
Subject: Re: [SciPy-Dev] cephes_smirnov never returns on mips/sparc/...
Date: Fri, 30 Mar 2012 22:27:14 -0400
On Fri, Mar 30, 2012 at 9:50 PM, Yaroslav Halchenko
<lists@onerussian.com> wrote:
> yeap -- that
>
> -  if (n <= 0 || e < 0.0 || e > 1.0)
> +  /* This comparison should assure returning NaN whenever
> +     e is NaN itself.  In original || form it would proceed */
> +  if (!(n > 0 && e >= 0.0 && e <= 1.0))
>
>
> resolved the stalling issue and now I am getting the same
> (1.0, nan, nan) as on x86 ... sent pull request
>
> https://github.com/scipy/scipy/pull/187
>
> patch is attached here as well
>
> so next I guess is to make it return sensible values for the .fit as it did
> before? ;)

sensible? or starting values?

Fitting now
[ 1.  0.  1.]
>>> import scipy
>>> scipy.__version__
'0.7.2'
>>>
>>> np.__version__
'1.4.1'

Josef

>
> On Fri, 30 Mar 2012, Yaroslav Halchenko wrote:
>
>> well -- imho it should have not even got to that point if e is
>> NaN.  Just started rebuilding with following patch:
>
>> -  if (n <= 0 || e < 0.0 || e > 1.0)
>> +  # This comparison should assure returning NaN whenever
>> +  # e is NaN itself.  In original || form it would proceed
>> +  if !(n > 0 && e >= 0.0 && e <= 1.0)
>>      return (NPY_NAN);
>
>
> --
> =------------------------------------------------------------------=
> Keep in touch                                     www.onerussian.com
> Yaroslav Halchenko                 www.ohloh.net/accounts/yarikoptic
> _______________________________________________
> SciPy-Dev mailing list
> SciPy-Dev@scipy.org
> http://mail.scipy.org/mailman/listinfo/scipy-dev




Added tag(s) pending. Request was from varun@users.alioth.debian.org to control@bugs.debian.org. (Fri, 20 Apr 2012 07:15:05 GMT) Full text and rfc822 format available.

Reply sent to Varun Hiremath <varun@debian.org>:
You have taken responsibility. (Fri, 20 Apr 2012 07:39:22 GMT) Full text and rfc822 format available.

Notification sent to Yaroslav Halchenko <debian@onerussian.com>:
Bug acknowledged by developer. (Fri, 20 Apr 2012 07:39:24 GMT) Full text and rfc822 format available.

Message #27 received at 653948-close@bugs.debian.org (full text, mbox):

From: Varun Hiremath <varun@debian.org>
To: 653948-close@bugs.debian.org
Subject: Bug#653948: fixed in python-scipy 0.10.1+dfsg1-2
Date: Fri, 20 Apr 2012 07:32:47 +0000
Source: python-scipy
Source-Version: 0.10.1+dfsg1-2

We believe that the bug you reported is fixed in the latest version of
python-scipy, which is due to be installed in the Debian FTP archive:

python-scipy-dbg_0.10.1+dfsg1-2_amd64.deb
  to main/p/python-scipy/python-scipy-dbg_0.10.1+dfsg1-2_amd64.deb
python-scipy_0.10.1+dfsg1-2.debian.tar.gz
  to main/p/python-scipy/python-scipy_0.10.1+dfsg1-2.debian.tar.gz
python-scipy_0.10.1+dfsg1-2.dsc
  to main/p/python-scipy/python-scipy_0.10.1+dfsg1-2.dsc
python-scipy_0.10.1+dfsg1-2_amd64.deb
  to main/p/python-scipy/python-scipy_0.10.1+dfsg1-2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 653948@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Varun Hiremath <varun@debian.org> (supplier of updated python-scipy package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Fri, 20 Apr 2012 02:37:28 -0400
Source: python-scipy
Binary: python-scipy python-scipy-dbg
Architecture: source amd64
Version: 0.10.1+dfsg1-2
Distribution: unstable
Urgency: low
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Changed-By: Varun Hiremath <varun@debian.org>
Description: 
 python-scipy - scientific tools for Python
 python-scipy-dbg - scientific tools for Python - debugging symbols
Closes: 648034 648036 651760 653948
Changes: 
 python-scipy (0.10.1+dfsg1-2) unstable; urgency=low
 .
   * debian/control:
     - Recommends: python-imaging (Closes: #648036)
     - Recommends: python-dev (Closes: #651760)
   * debian/patches:
     - Add kolmogorov.diff, thanks to Yaroslav Halchenko (Closes: #653948)
     - Add kde.diff (Closes: #648034)
Checksums-Sha1: 
 b3219e46ba9a43e5e29a4cf13f9ba24d21e8a194 2452 python-scipy_0.10.1+dfsg1-2.dsc
 795849bfecb35fc6dca9852a97791b8d7b14f507 10906 python-scipy_0.10.1+dfsg1-2.debian.tar.gz
 2c5d6e599b8b859a473eddcd17ea53285a672e2a 11610694 python-scipy_0.10.1+dfsg1-2_amd64.deb
 6a3e2759fae85251c7808b0a312e9da273a64291 26258410 python-scipy-dbg_0.10.1+dfsg1-2_amd64.deb
Checksums-Sha256: 
 6ad4488992bf16eb6bf3416c380b1f03820f8c966bcab32e89c6449cb852aafa 2452 python-scipy_0.10.1+dfsg1-2.dsc
 bd7cd1120edbfbd138edd4ade7b975ad49cb302f48eead8f2630219fdeec5e47 10906 python-scipy_0.10.1+dfsg1-2.debian.tar.gz
 8deb75883e81bf793a8f9337fc1b8b436eaf6869d8ff34b69143537eab3360ed 11610694 python-scipy_0.10.1+dfsg1-2_amd64.deb
 d07f69b681768722b8cdd3525255dbd01eec697cdd831d6735f32b296c1ae39f 26258410 python-scipy-dbg_0.10.1+dfsg1-2_amd64.deb
Files: 
 18eea979acdbd1c584cab830283ccc53 2452 python extra python-scipy_0.10.1+dfsg1-2.dsc
 a5bd75415512fcbc9fc2a47ef49a026b 10906 python extra python-scipy_0.10.1+dfsg1-2.debian.tar.gz
 0a819f4505dbfcabc0105243d0c0ea99 11610694 python extra python-scipy_0.10.1+dfsg1-2_amd64.deb
 a404bc96a41ac322a0386be07df6cca0 26258410 debug extra python-scipy-dbg_0.10.1+dfsg1-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCgAGBQJPkQxnAAoJEHA3PPEpDbnOvMkP/3Ezf3ibP6EHUaiwDjcD9c91
DkrolISHJGWjzneyM64b0Dr7joXUDiaFsC6bvk50AP2G5zaCQyqAXgEDp5SaZMPh
JaSXB20JianOltbi33FB+sB7eAHmcbq2OTCdAUlZpn6RJdqQfPCYalohsDXbkMJt
82jVZjs+K9giXP5fNEfinIk5I57EqAlzd1edf1IzHcMXHH+6MOyouuSBdVORo47W
6kiT5PInhhhCx0/40mX/BdsPSQ6dnla6cd+1+e8OMQvr3zyG4EdA3L65mRYA4Zac
klxFGAyFS0tnWC2O3VfkKSK/zZhnC7aKYBzIsDf2TSPYm5jefLoQRAdrteDVyd0E
86PSXuydtNh1ffZZYNQ1OAiOXqfFTytppaCcnWMoRvzq8MhhUgGT7OJLsyo5mkNL
I3CaY1wVH0NFCRiUjhT9lT9HkcIIBnsPdnvgmzjTHOLDB82uzAGcsh5UvhACFgHl
cEfahnQEQFwRJAGmvN31d+yIvFSPuQtkQTVNTauX9bUzkr0OLaQaI8wmp3HzgChj
gx3GCFWt5LPXWuKLCwVR8BJF0dtdGG6p0nuC/UG/HTBBa82RQYn32piJSObfvQG1
bzR+ndQC0iIg4WZ+b3s1EIMhX78K0svMUBzrmOi6eLG2EbPcpVTQCXGbfQTP7SKj
w0mUSkq3rbJpOTXK1k8u
=j3Hh
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#653948; Package python-scipy. (Mon, 14 May 2012 13:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Yaroslav Halchenko <yoh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Mon, 14 May 2012 13:51:04 GMT) Full text and rfc822 format available.

Message #32 received at 653948@bugs.debian.org (full text, mbox):

From: Yaroslav Halchenko <yoh@debian.org>
To: 653948@bugs.debian.org
Cc: Varun Hiremath <varun@debian.org>
Subject: Re: [Python-modules-team] Bug#653948: marked as done (cephes_smirnov never returns on mips)
Date: Mon, 14 May 2012 09:46:59 -0400
[Message part 1 (text/plain, inline)]
Hi Varun,

thanks for taking care and adopting my patch.  now it got accepted
upstream and I wanted to mention that they refactored few other
comparisons -- so it might be wise for Debian to adopt that patch as
well (attaching).

Cheers

On Fri, 20 Apr 2012, Debian Bug Tracking System wrote:

> Your message dated Fri, 20 Apr 2012 07:32:47 +0000
> with message-id <E1SL8Kl-0001gH-A5@franck.debian.org>
> and subject line Bug#653948: fixed in python-scipy 0.10.1+dfsg1-2
> has caused the Debian Bug report #653948,
> regarding cephes_smirnov never returns on mips
> to be marked as done.

> This means that you claim that the problem has been dealt with.
> If this is not the case it is now your responsibility to reopen the
> Bug report if necessary, and/or fix the problem forthwith.

> (NB: If you are a system administrator and have no idea what this
> message is talking about, this may indicate a serious mail system
> misconfiguration somewhere. Please contact owner@bugs.debian.org
> immediately.)
-- 
Yaroslav O. Halchenko
Postdoctoral Fellow,   Department of Psychological and Brain Sciences
Dartmouth College, 419 Moore Hall, Hinman Box 6207, Hanover, NH 03755
Phone: +1 (603) 646-9834                       Fax: +1 (603) 646-1419
WWW:   http://www.linkedin.com/in/yarik        
[0003-BUG-special-nan-safety-in-smirnovi-kolmogi.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 12 Jun 2012 07:41:19 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 21:42:12 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.